Story4/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story1/', include('story1.urls')),
    path('story5/', include('story5.urls')),
    path('story6/', include('story6.urls')),
    path('story7/', include('story7.urls')),
    path('story8/', include('story8.urls')),
    path('story9/', include('story9.urls')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'story4'

urlpatterns = [
    path('', views.home, name='home'),
    path('story4/', views.story4, name='story4'),
    path('story4/message/', views.message, name='message'),
    path('story4/more/', views.more, name='more'),
]

story5/urls.py
from django.urls import path

from . import views

app_name = 'story5'

urlpatterns = [
    path('', views.story5, name='story5'),
    path('addStatus/', views.addStatus, name='addStatus'),
    path('addCourse/', views.addCourse, name='addCourse'),
    path('course/<str:pk_test>/', views.course, name='course'),
    path('updateStatus/<str:pk>/', views.updateStatus, name='updateStatus'),
    path('removeStatus/<str:pk>/', views.removeStatus, name='removeStatus'),
    path('updateCourse/<str:pk>/', views.updateCourse, name='updateCourse'),
    path('removeCourse/<str:pk>/', views.removeCourse, name='removeCourse'),
]

main/models.py
from django.db import models

# Create your models here.

story5/models.py
from django.db import models

# Create your models here.

class Course(models.Model) :
    name = models.CharField(max_length=12, null=True)
    sks = models.DecimalField(max_digits=1, decimal_places=0)
    semester = models.DecimalField(max_digits=1, decimal_places=0, null=True)
    ta = {('2019/2020', '2019/2020'), ('2020/2021', '2020/2021'), ('Other', 'Other')}
    year = models.CharField(max_length=25, null=True, choices=ta)
    note = models.CharField(max_length=25, null=True)
    
    def __str__(self):
        return self.name

class Matkul(models.Model):
    stat = {('Done', 'Done'), ('Not Yet', 'Not Yet'), ('Ongoing', 'Ongoing')}

    course = models.ForeignKey(Course, null=True, on_delete=models.CASCADE)
    status = models.CharField(max_length=10, null=True, choices=stat)
    
    def __str__(self):
        return self.course.name

story5/forms.py
from django.forms import ModelForm
from .models import Matkul, Course

class MatkulForm(ModelForm):
    class Meta:
        model = Matkul
        fields = '__all__'

class CourseForm(ModelForm):
    class Meta:
        model = Course
        fields = '__all__'

main/views.py
from django.shortcuts import render, redirect
from .models import *


def home(request):
    return render(request, 'main/home.html')

def story4(request):
    return render(request, 'main/story4.html')    

def message(request):
    return render(request, 'main/message.html')

def more(request):
    return render(request, 'main/more.html')  

story5/views.py
from django.shortcuts import render, redirect
from .models import *
from .forms import MatkulForm, CourseForm

def story5(request):
    matkuls = Matkul.objects.all()
    courses = Course.objects.all()

    context = {'matkuls' : matkuls, 'courses' : courses}

    return render(request, 'main/story5.html', context)

def course(request, pk_test):
    course = Course.objects.get(id=pk_test)
    context = {'course' : course}
    return render(request, 'main/course.html', context)

def addStatus(request):
    matkuls = Matkul.objects.all()
    form = MatkulForm()
    if request.method == 'POST':
        form = MatkulForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('/story5')

    context ={'form' : form, 'matkuls' : matkuls, 'query':'add'}

    return render(request, 'main/addStatus.html', context)

def addCourse(request):
    courses = Course.objects.all()
    form = CourseForm()
    if request.method == 'POST':
        form = CourseForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('/story5')

    context ={'form' : form, 'courses':courses, 'query':'add'}

    return render(request, 'main/addCourse.html', context)

def updateStatus(request, pk):
    matkuls = Matkul.objects.all()
    matkul = Matkul.objects.get(id=pk)
    form = MatkulForm(instance=matkul)

    if request.method == 'POST':
        form = MatkulForm(request.POST, instance=matkul)
        if form.is_valid():
            form.save()
            return redirect('/story5')

    context = {'form' : form, 'matkuls':matkuls, 'query':'update'}
    return render(request, 'main/addStatus.html', context)

def removeStatus(request, pk):
    matkuls = Matkul.objects.get(id=pk)
    context = {'item' : matkuls}

    if request.method == 'POST':
        matkuls.delete()
        return redirect('/story5')

    return render(request, 'main/remove.html', context)
    
def updateCourse(request, pk):
    courses = Course.objects.all()
    course = Course.objects.get(id=pk)
    form = CourseForm(instance=course)

    if request.method == 'POST':
        form = CourseForm(request.POST, instance=course)
        if form.is_valid():
            form.save()
            return redirect('/story5')

    context = {'form' : form, 'courses':courses, 'query':'update'}
    return render(request, 'main/addCourse.html', context)

def removeCourse(request, pk):
    courses = Course.objects.get(id=pk)
    context = {'item' : courses}

    if request.method == 'POST':
        courses.delete()
        return redirect('/story5')

    return render(request, 'main/delete.html', context)

story5/templates/main/addCourse.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 5.1</title>
{% endblock meta %}

{% block content %}
<h5 class="judul" style="text-align: left; padding-left: 0; transform: translateX(5%);">{{query}} Course</h5>
<form action="" method="POST" style="transform: translateX(5%); width: 95%;">
    {% csrf_token %}
    {{form.as_p}}
    <a href="{% url 'story5:story5' %}" class="back-remove">Back</a>
    <input type="submit" name="submit" class="button-sendiri"">
</form><br><br>

<h5 style="transform: translateX(5%);">Current SKS</h5>
    <table class="table table-sm" id="table-story5" style="width: 60%; margin-left: 5%;">
      <tr style="border-bottom: 2px solid #102B3E; border-top: 2px solid #102B3E;">
          <th>Course</th>
          <th>SKS</th>
          <th>Details</th>
      </tr>

      {% for course in courses %}
        <tr style="border-bottom: 1px solid #102B3E;">
          <td>{{course.name}}</td>
          <td>{{course.sks}}</td>
          <td><a href="{% url 'story5:course' course.id %}"><button class="button-sendiri">View</button></a></td>
        </tr>
      {% endfor %}
    </table><br><br>
{% endblock %}

{% block foot %}
{% endblock %}

story5/templates/main/addStatus.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 5.2</title>
{% endblock meta %}

{% block content %}
<h5 class="judul" style="text-align: left; padding-left: 0; transform: translateX(5%);">{{query}} Status</h5>
<form action="" method="POST" style="transform: translateX(5%); width: 95%;">
    {% csrf_token %}
    {{form.as_p}}
    <a href="{% url 'story5:story5' %}" class="back-remove">Back</a>
    <input type="submit" name="submit" class="button-sendiri">
</form><br><br>

<h5 style="transform: translateX(5%); width: 95%; padding-top: 10px;">Current Status</h5>
    <table class="table table-sm" id="table-story5" style="width: 50%; margin-left: 5%;">
        <tr style="border-bottom: 2px solid #102B3E; border-top: 2px solid #102B3E;">
            <th>Course</th>
            <th>Status</th>
        </tr>

        {% for matkul in matkuls %}
          <tr style="border-bottom: 1px solid #102B3E;">
            <td>{{matkul.course}}</td>
            <td>{{matkul.status}}</td>
        </tr>
        {% endfor %}
    </table><br><br>
{% endblock %}

{% block foot %}
{% endblock %}

story5/templates/main/course.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 5.3</title>
{% endblock meta %}

{% block content %}
<h5 class="judul">Course Details</h5>
<!-- <h5 style="transform: translateX(2%); width: 95%; padding-top: 10px;">{{course.name}}</h5> -->
<div style="padding-bottom: 20px; transform: translateX(3%);">
    <h5>{{course.name}}</h5>
    <a href="{% url 'story5:updateCourse' course.id %}"><button class="button-sendiri">Update</button></a>
    <a href="{% url 'story5:removeCourse' course.id %}"><button class="button-sendiri">Remove</button></a>
</div>
    <table class="table table-sm" id="table-story5" style="max-width: 95%; margin-left: 2.5%;">
        <tr style="border-top: 2px solid #102B3E;">
            <th style="border-right: 2px solid #102B3E; width: 20%;">Course Name</th>
            <td style="text-align: left; padding-left: 2.5%;">{{course.name}}</td>
        </tr>
        <tr>
            <th style="border-right: 2px solid #102B3E; width: 20%;">SKS</th>
            <td style="text-align: left; padding-left: 2.5%;">{{course.sks}}</td>
        </tr>
        <tr>
            <th style="border-right: 2px solid #102B3E; width: 20%;">Semester</th>
            <td style="text-align: left; padding-left: 2.5%; ">{{course.semester}}</td>
        </tr>
        <tr>
            <th style="border-right: 2px solid #102B3E; width: 20%;">Year</th>
            <td style="text-align: left; padding-left: 2.5%; ">{{course.year}}</td>
        </tr>
        <tr style="border-bottom: 2px solid #102B3E;">
            <th style="border-right: 2px solid #102B3E; width: 20%;">Note</th>
            <td style="text-align: left; padding-left: 2.5%; ">{{course.note}}</td>
        </tr>
    </table>
<div style="padding-bottom: 20px; transform: translateX(3%);">
    <a href="{% url 'story5:story5' %}"><button class="button-sendiri">Back</button></a>
</div>
{% endblock %}

{% block foot %}
{% endblock %}

story5/templates/main/delete.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 5.4</title>
{% endblock meta %}

{% block content %}
<h5 class="judul">Removing Course</h5>
<div style="text-align: right; margin-right: 60px; margin-left: 60px;">
<h5>Are you sure  you want to delete {{item}}?</h5>
<form action="{% url 'story5:removeCourse' item.id %}" method="POST">
    {% csrf_token %}
    <a href="{% url 'story5:story5' %}" class="back-remove">Back</a>
    <input type="submit" value="Confirm" class="button-sendiri">
</form>
</div>
{% endblock %}

{% block foot %}
{% endblock %}

story5/templates/main/remove.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 5.5</title>
{% endblock meta %}

{% block content %}
<h5 class="judul">Removing Item</h5>
<div style="text-align: right; margin-right: 60px; margin-left: 60px;">
<h5>Are you sure  you want to delete {{item}}?</h5>
<form action="{% url 'story5:removeStatus' item.id %}" method="POST">
    {% csrf_token %}
    <a href="{% url 'story5:story5' %}" class="back-remove">Back</a>
    <input type="submit" value="Confirm" class="button-sendiri">
</form>
</div>
{% endblock %}

{% block foot %}
{% endblock %}

story5/templates/main/story5.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter Five</title>
{% endblock meta %}

{% block content %}
  <h5 class="judul">List of Courses</h5>
  <hr style="border-top: 5px dashed #102B3E;">
  <div class="story5">
    <h5 style="transform: translateX(2%);">SKS</h5>
    <div style="padding-top: 10px; padding-bottom: 20px; transform: translateX(2%);">
      <a href="{% url 'story5:addCourse' %}"><button class="button-sendiri">Add Course</button></a></div>
    <table class="table table-sm" id="table-story5" style="width: 60%; margin-left: 2.5%;">
      <tr style="border-bottom: 2px solid #102B3E; border-top: 2px solid #102B3E;">
          <th>Course</th>
          <th>SKS</th>
          <th>Details</th>
      </tr>

      {% for course in courses %}
        <tr style="border-bottom: 1px solid #102B3E;">
          <td>{{course.name}}</td>
          <td>{{course.sks}}</td>
          <td><a href="{% url 'story5:course' course.id %}"><button class="button-sendiri">View</button></a></td>
        </tr>
      {% endfor %}
    </table>
    <h5 style="transform: translateX(2%); width: 95%; padding-top: 10px;">STATUS</h5>
    <div style="padding-top: 10px; padding-bottom: 20px; transform: translateX(2%);">
      <a href="{% url 'story5:addStatus' %}"><button class="button-sendiri">Add Status</button></a></div>
    <table class="table table-sm" id="table-story5" style="width: 95%; margin-left: 2.5%;">
        <tr style="border-bottom: 2px solid #102B3E; border-top: 2px solid #102B3E;">
            <th>Course</th>
            <th>Status</th>
            <th>Update</th>
            <th>Remove</th>
        </tr>

        {% for matkul in matkuls %}
          <tr style="border-bottom: 1px solid #102B3E;">
            <td>{{matkul.course}}</td>
            <td>{{matkul.status}}</td>
            <td><a href="{% url 'story5:updateStatus' matkul.id %}" ><button class="button-sendiri">Update</button></a></td>
            <td><a href="{% url 'story5:removeStatus' matkul.id %}" ><button class="button-sendiri">Remove</button></a></td>
          </tr>
        {% endfor %}
    </table>
  </div><br><br><br>
{% endblock content %}
{% block foot %}
{% endblock %}